#pragma once
#include "domain/serial_number.h"
#include "domain/software_version.h"

#include <iostream>

namespace spin
{
    struct ToolInfo
    {
        ToolInfo(SerialNumber serialNumber, SoftwareVersion softwareVersion, int minSpeed, int maxSpeed)
            : serialNumber_(serialNumber), softwareVersion_(softwareVersion), minSpeed_(minSpeed), maxSpeed_(maxSpeed) {}

        inline friend std::ostream &operator<<(std::ostream &out, const ToolInfo &toolInfo)
        {
            out << "serialNumber: " << toolInfo.serialNumber_;
            out << "softwareVersion: " << toolInfo.softwareVersion_;
            out << "minSpeed: " << toolInfo.minSpeed_ << std::endl;
            out << "maxSpeed: " << toolInfo.maxSpeed_ << std::endl;
            return out;
        }

        std::string toString() const
        {
            std::ostringstream oss;
            oss << *this;
            return oss.str();
        }

        SerialNumber serialNumber_;
        SoftwareVersion softwareVersion_;
        int minSpeed_;
        int maxSpeed_;
    };

} // namespace spin
